cls
@echo off
setlocal enabledelayedexpansion
color 0A

set Hinweis=Bitte lesen Sie unbedingt die Anleitungen zu diesem Skript!

rem --------- Optional: An die eigenen Verhaeltnisse anpassen -----------

rem Wenn das Skript Windows nach Abschluss der Sicherung herunterfahren soll,
rem setzen Sie die Variable der Variable "shutdown" von 0 auf 1.

set Shutdown=0

rem Pfad zum Ordner fr das Skript selbst, vshadow.exe und das 
rem Reset-Image setzen, etwa d:\resetimage\
rem Ohne Anpassung verwendet das Skript den Ordner, in dem es liegt.
rem Keine Leerzeichen im Pfad! Mit abschlieendem "\"!

set workdir=%~d0%~p0

rem --------- Optional: Zustzliche Anpassungen nur fr Windows 8.1 -----------

rem Dieses Skript kann das zuletzt erstellte Image als Wiederherstellungs-Image 
rem festlegen. Es wird dann wiederhergestellt, wenn Sie in den PC-Einstellungen
rem unter Update/Wiederherstellung den Punkt "Alles entfernen und Windows neu
rem installieren" auswhlen. Wenn Sie das wollen, ndern Sie den Wert der Variable 
rem "Reset" von 0 auf 1.
rem DIESE OPTION FUNKTIONIERT NUR UNTER WINDOWS 8.1!

set Reset=0

rem Dieses Skript kann das zuletzt erstellte Image als Auffrischungs-Image 
rem festlegen. Es wird dann wiederhergestellt, wenn Sie in den PC-Einstellungen
rem unter Update/Wiederherstellung den Punkt "PC ohne Auswirkungen auf die Dateien
rem auffrischen" auswhlen. Wenn Sie das wollen, ndern Sie den Wert der Variable 
rem "Refresh" von 0 auf 1. ACHTUNG: Es wird dann ein weiteres Image erzeugt, das 
rem Aktivieren dieser Option kostet also zustzlichen Platz auf dem Zielmedium!
rem DIESE OPTION FUNKTIONIERT NUR UNTER WINDOWS 8.1!

set Refresh=0

rem ------------- Ende der Anpassungen -----------

echo.
echo ************************************
echo *** Willkommen bei c't-wimage v2 ***
echo ************************************
echo.
echo %hinweis%
echo.

set description=
set operation=*** Befehlszeilen-Argumente pruefen ***
:parseargs
if "%1"=="" goto endargs
rem hilfe erwuenscht?
if /i "%1"=="/?" goto hilfe
if /i "%1"=="-?" goto hilfe
if /i "%1"=="/h" goto hilfe
if /i "%1"=="-h" goto hilfe
if /i "%1"=="--h" goto hilfe
if /i "%1"=="/help" goto hilfe
if /i "%1"=="-help" goto hilfe
if /i "%1"=="--help" goto hilfe
rem Beschreibung fr das Image gewnscht?
set option=0
if /i "%1"=="/d" set option=1
if /i "%1"=="-d" set option=1
if %option%==1 (
  set description="%~2"
  shift /1
  shift /1
  goto parseargs
)
rem Image als Wiederherstellungs-Image festlegen?
if /i "%1"=="/reset" set option=1
if /i "%1"=="-reset" set option=1
if %option%==1 (
  set Reset=1
  shift /1
  goto parseargs
)
rem Image als Auffrischungs-Image festlegen?
if /i "%1"=="/refresh" set option=1
if /i "%1"=="-refresh" set option=1
if %option%==1 (
  set Refresh=1
  shift /1
  goto parseargs
)
rem Nach dem Sichern herunterfahren?
if /i "%1"=="/s" set option=1
if /i "%1"=="-s" set option=1
if /i "%1"=="/shutdown" set option=1
if /i "%1"=="-shutdown" set option=1
if %option%==1 (
  set Shutdown=1
  shift /1
  goto parseargs
)
color 0C
echo *** Unbekanntes Befehlszeilen-Argument: %1 ***
echo.
goto hilfe
:endargs

echo *** Einige Pruefungen vorab ... ***
echo.

set operation=*** Skript braucht mindestens Windows 8.1 ***
for /f "tokens=3" %%a in ('reg query ^"HKLM^\SOFTWARE^\Microsoft^\Windows NT^\CurrentVersion^" /v ^"currentversion^"') do set version=%%a
if %version% lss 6.3 goto fehler1

set operation=*** Reset und Refresh ab Windows 10 deaktivieren ***
for /f "tokens=4" %%a in ('reg query ^"HKLM^\SOFTWARE^\Microsoft^\Windows NT^\CurrentVersion^" /v ^"ProductName^"') do set version=%%a
if errorlevel 1 goto fehler1
if not "%version%" == "8.1" (
  set Reset=0
  set Refresh=0
)

set operation=*** Dieses Skript ist nur fuer 32-Bit-Windows ***
if exist "%ProgramFiles(x86)%" goto fehler1

set operation=*** Skript muss mit Administratorrechten laufen ***
whoami /groups | find "S-1-16-12288" > nul
if errorlevel 1 goto fehler1

set operation=*** Arbeitsverzeichnis darf nicht auf dem Windows-Laufwerk liegen ***
if %~d0 equ %systemdrive% goto fehler1

set operation=*** vshadow.exe muss im Arbeitsverzeichnis liegen ***
set vshadow=vshadow32.exe
if not exist %workdir%%vshadow% goto fehler1

set operation=*** Im Arbeitsverzeichnis muss ein Ordner "Sources" liegen ***
if not exist %workdir%sources goto fehler1

set operation=*** In der Install.wim sollen nicht mehr als 1000 Images enthalten sein ***
set action=append-image 
if not exist %workdir%sources\install.wim (
  set action=capture-image /compress:max
) else (
  set letztenummer=1
  for /f "tokens=1,2* delims=: " %%L in ('%windir%\system32\dism /get-wiminfo /wimfile:%workdir%sources\install.wim') do (
    if "%%L"=="Index" set /a letztenummer=%%M
  )
  if !letztenummer! gtr 1000 goto fehler1
)

echo *** Keine Probleme gefunden, jetzt geht es los ***
echo.

echo *** Vorbereitungen ... ***
set operation=*** RunOnce-Schluessel hinzufuegen zum Restaurieren von WinRE nach Wiederherstellung ***
reg add HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce /f /v "enablewinre" /d "reagentc /enable" >nul 2>nul
if errorlevel 1 goto fehler2

set operation=*** Windows RE auf Windows-Partition verschieben ***
reagentc /disable >nul 2>nul
if errorlevel 1 goto fehler2

set operation=*** Freien Laufwerksbuchstaben fuer Schattenkopie suchen ***
echo.
echo %operation%
for %%l in (P Q R S T U V W X Y Z D E F G H I J K L M N O) do (  
  set sklw=%%l
  mountvol %%l: /L >nul
  if errorlevel 1 (
    subst | findstr /B "%%l:" >nul
    if errorlevel 1 (
      net use %%l: >nul 2>&1
      if errorlevel 1 goto weiter
    )
  )
)
goto fehler2
:weiter
echo Verwende %sklw%:

echo.
set operation=*** Schattenkopie der Windows-Partition erzeugen ***
echo.
echo %operation%
%workdir%%vshadow% -p -script=%workdir%vshadowtemp.cmd %systemdrive% >nul 2>nul
if errorlevel 1 goto fehler2
call %workdir%vshadowtemp.cmd >nul 2>nul
if errorlevel 1 goto fehler2
%workdir%%vshadow% -el=%SHADOW_ID_1%,%sklw%:
if errorlevel 1 goto fehler2

echo.
echo.
set operation=*** Image erstellen/anhaengen ***
echo %operation%
echo.
echo Es kann ziemlich lange dauern, bis die Fortschrittsanzeige erscheint.
echo Nach Erreichen der 100 Prozent kann es wieder dauern, bis es weiter geht.
echo. 
for /f  "tokens=4 delims=] " %%i in ('ver') do set wos=%%i
if "%wos%"=="6.3.9600" set wos="8.1"
if %description%.==. set description="%date% %time:~0,5% Windows %wos% auf %computername%"
%windir%\system32\dism /%action% /imagefile:%workdir%sources\install.wim /capturedir:%sklw%: /name:"%date:~6,4%-%date:~3,2%-%date:~0,2% %time:~0,5% %computername% %wos%" /description:%description% /checkintegrity /verify /scratchdir:%workdir%
if errorlevel 1 goto fehler2

echo.
set operation=*** Schattenkopie wieder entfernen ***
echo. 
echo %operation%
%workdir%%vshadow% -ds=%SHADOW_ID_1%
if errorlevel 1 goto fehler2

set operation=*** Windows das frische Image bekanntmachen ***
if not "%reset%" equ "1" goto next1
echo.
echo.
echo %operation%
set lastindex=0
for /f "tokens=*" %%L in ('%windir%\system32\dism /get-wiminfo /wimfile:%workdir%sources\install.wim ^| find "Index"') do (
  set counter=%%L
  set lastindex=!counter:~8,-1!
)
if %lastindex% equ 0 goto fehler2
reagentc /setosimage /path %workdir%sources\install.wim /index %lastindex%
if errorlevel 1 goto fehler2
:next1

set operation=*** Backup-Liste erzeugen ***
%windir%\system32\dism /english /get-wiminfo /wimfile:%workdir%sources\install.wim > %workdir%Backupliste.txt
if errorlevel 1 goto fehler2

echo.
echo *** Aufraeumen ***
set operation=*** Windows RE wieder an alte Stelle zurckverschieben ***
reagentc /enable >nul 2>nul
if errorlevel 1 goto fehler2

set operation=*** RunOnce-Schluessel wieder loeschen ***
reg delete HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce /v "enablewinre" /f >nul 2>nul
if errorlevel 1 goto fehler2

set operation=*** Und nun doch das Refresh-Image erzeugen ***
if not "%refresh%" equ "1" goto next2
echo. 
echo.
echo %operation%
recimg /createimage %workdir%sources
if errorlevel 1 goto fehler2
:next2

echo.
echo.
echo *** Fertig! ***
if "%shutdown%" equ "1" shutdown -s -t 0
pause
goto :eof

rem Bedingung nicht erfllt
:fehler1
set text=Folgende Bedingung wurde nicht erfuellt: 
goto Fehlerausgabe

rem Fehler bei der Durchfuehrung
:fehler2
set text=Operation fehlgeschlagen:
goto Fehlerausgabe

:fehlerausgabe
color 0C
echo.
echo %text%
echo.
echo %operation%
echo.
echo %hinweis%
echo.
echo Raeume hinter mir auf...
reagentc /enable >nul 2>nul
reg delete HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce /v "enablewinre" /f >nul 2>nul
%workdir%%vshadow% -ds=%SHADOW_ID_1% >nul 2>nul
echo Aufraeumen fertig.
pause
goto :eof

rem Abbruch durch Benutzer
:abbruch
echo Abbruch durch Benutzer
pause
goto :eof

:hilfe
echo.
echo %~nx0 ergaenzt die Datei Install.wim durch ein weiteres Image. 
echo Fehlt die Datei, wird eine neue erzeugt.
echo.
echo %~nx0 versteht folgende Befehlszeilen-Argumente:
echo   /Reset            - Das neue Image als Wiederherstellungs-Image festlegen
echo   /Refresh          - Das neue Image als Auffrischungs-Image festlegen
echo   /S                - Windows nach Abschluss der Sicherung herunterfahren
echo   /Shutdown         - Windows nach Abschluss der Sicherung herunterfahren
echo   /D "Beschreibung" - "Beschreibung" als Beschreibung der Sicherung speichern
echo.
echo %~nx0 muss mit Administratorrechten gestartet werden!
echo.
echo %Hinweis%
echo.
pause
goto :eof
;
REM Erstellt 2014/2015/2016 von Axel Vahldiek/c't
REM mailto: axv@ct.de

REM Danke an die Nutzer tdklaus und fredo61 aus dem c't-Forum fr ihre Ideen, 
REM die hier ins Skript miteingeflossen sind, sowie an alle anderen, die hier 
REM mitgeholfen haben!